<template>
  <div class="ac-kanban">
    <div
      class="ac-kanban__column px-3"
      v-for="position in positions"
      :key="position"
    >
      <draggable
        v-model="collections_data[items[position].ac_collection]"
        :disabled="!draggable"
        :sortable="headers_sortable"
        group="kanban"
        @change="on_change"
        draggable=".kanban-item"
      >
        <h3
          class="border p-2"
          slot="header"
        >
          {{ items[position].label }}
        </h3>

        <div
          v-for="element in collections_data[items[position].ac_collection]"
          :key="element[item_key]"
          class="kanban-item"
        >
          <!-- Slot for each draggable item -->
          <slot name="kanban-item" :item="element"></slot>
        </div>
      </draggable>

      <!-- require this to have access to collection  -->
      <slot class="d-none" :name="items[position].ac_collection"></slot>
    </div>
  </div>
</template>


<script>
import draggable from 'vuedraggable'

/**
 * ac Kanban component
 * @requires VueBootstrap
 * @requires vuedraggable
 */

export default {
  name: 'ac-kanban',

  components: {
    draggable,
  },

  props: {
    /**
     * @param {object} items - Object that holds items for drag-n-drop
     */
    items: {
      type: Object,
      required: true,
    },

    /**
     * @param {boolean} draggable - Indicates if drag-n-drop enabled
     */
    draggable: {
      type: Boolean,
      required: true,
    },

    /**
     * @param {string|number} item_key - Key inside each draggable item for unique identification
     */
    item_key: {
      type: [String, Number],
      required: true,
    },

    /**
     * @param {bolean} headers_sortable -  Indicates if sorting enabled
     */
    headers_sortable: {
      type: Boolean,
      required: true,
    },

    /**
     * @param {array} positions - Array used to render cols in specific positions
     */
    positions: {
      type: Array,
      required: true,
    },
  },

  data() {
    return {
      collections: {},
      collections_data: {},
    }
  },

  created() {
    /**
     * On collection_added event register component locally
     */
    this.$on('collection_added', (e) => {
      this.collections[e.component.$vnode.data.ref] = e.component
    })
  },

  mounted() {
    this.get_collections_data()
  },

  methods: {
    /**
     * @function get_collections_data - get data from each ac-collection
     */
    get_collections_data() {
      Object.keys(this.collections).forEach((key) => {
        this.collections[key].$on('success', (e) => {
          this.collections_data = {
            ...this.collections_data,
            [key]: e,
          }
        })

        this.collections[key].set_ajax()
      })
    },

    on_change(e) {
      /**
       * @event on_change
       * event is triggered when corresponding array is altered due to drag-and-drop operation.
       * @property {object} event - Type of change and corresponding data.
       */
      console.log(e)
      this.$emit('on_change', e)
    },
  },
}
</script>

<style scoped>
  .ac-kanban {
    display: flex;
  }

  .ac-kanban__column {
    flex: auto;
  }
</style>
